# Copyright (c) 2000-2001 LOGILAB S.A. (Paris, FRANCE).
# http://www.logilab.fr/ -- mailto:contact@logilab.fr
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
__revision__ = '$Id: RPCFactory.py,v 1.4 2001/12/21 13:52:51 syt Exp $'

DEFAULT = 'pyro'

def create_server(port, handler, type=DEFAULT, debug=0):
    if type == 'xmlrpc':
        import xmlrpc
        return xmlrpc.XMLRPCServer(port, handler)
    elif type == 'pyro':
        import pyro
        return pyro.PYROServer(port, handler, debug)
        
def create_proxy(uri):
    type, host, port, name = decode_uri(uri)
    if type == 'xmlrpc':
        import xmlrpc
        return xmlrpc.XMLRPCProxy('http://%s:%s' % (host, port))
    elif type == 'pyro':
        import pyro
        return pyro.PYROProxy(uri).obj

def decode_uri(uri):
    addr, name = uri.split('/')
    proto, host, port = addr.split(':')
    return (proto, host, port, name)

def encode_uri(proto, host, port, name=''):
    host = host.split('.')[0]
    return '%s:%s:%s/%s' % (proto, host, port, name)

class ServerInterface:
    def call(self, method, params):
        # server must have a methods handler with references to
        # objects whose methods are shared, and the EXPORTED_METHODS
        # dictionnary which lists the shared methods and gives the
        # objects which provides these methods.
        raise Exception('not implemented')

class ProxyInterface:
    def request(self, method, param):
        raise Exception('not implemented')

